#!/bin/sh
#******** cleaning ****************************
rm -f *err *lst *.p *.d80 *.inc

#******* compile and prepare MDOS3 binary files **********
#maketap zxcdp 18432
asl zxcdp.a80 -L -E zxcdp.err
p2bin zxcdp.p -r \$-\$
bin2tap zxcdp.bin -o zxcdp.tap -a 18432
asl runner.a80 -a -L -E runner.err
#p2bin runner.p -r \$-\$ -l 0
p2bin runner.p -r 8192-16383
asl nmi.a80 -a -L -E nmi.err
p2bin nmi.p -r 8192-16383
asl mdos1.a80 -L -E mdos1.err
p2bin mdos1.p -r 0-16383
asl mdos2.a80 -L -E mdos2.err
p2bin mdos2.p -r 0-16383
rm -f *.p
cat nmi.err mdos1.err mdos2.err zxcdp.err runner.err > mdos3.err
rm -f nmi.err mdos1.err mdos2.err zxcdp.err runner.err
if [ -s mdos3.err ] 
then
 if [ -n "$DISPLAY" ]; then kdialog --msgbox 'Chybna kompilace' 0 0; else dialog --msgbox 'Chybna kompilace' 0 0; fi
 if [ -n "$DISPLAY" ]; then kdialog --textbox mdos3.err 0 0; else dialog --textbox mdos3.err 0 0; fi
else
 rm -f mdos3.err
 split mdos1.bin mdos1_ -b 8k
 #vystup mdos1_aa a mdos1_ab soubory a budou vzdy 2
 mv mdos1_aa mdos1_3.bin
 mv mdos1_ab mdos1_0.bin
 cp nmi.bin mdos1_1.bin
 cp runner.bin mdos1_2.bin
 bin2tap mdos1_3.bin -a 0
 bin2tap mdos1_0.bin -a 8192
 bin2tap mdos1_1.bin -a 8192
 bin2tap mdos1_2.bin -a 8192
 
 split mdos2.bin mdos2_ -b 8k
 #vystup mdos2_aa a mdos2_ab soubory a budou vzdy 2
 mv mdos2_aa mdos2_3.bin
 mv mdos2_ab mdos2_0.bin
 cp nmi.bin mdos2_1.bin
 cp runner.bin mdos2_2.bin
 bin2tap mdos2_3.bin -a 0
 bin2tap mdos2_0.bin -a 8192
 bin2tap mdos2_1.bin -a 8192
 bin2tap mdos2_2.bin -a 8192

 #******* prepare helpscreen and mdos3 programs********
        # 1. binary files MDOS3
cat mdos1_3.tap mdos1_0.tap mdos1_1.tap mdos1_2.tap mdos2_3.tap mdos2_0.tap mdos2_1.tap mdos2_2.tap >> mdos3.tap
rm -f mdos1_?.tap mdos2_?.tap
        # 2. important include files
bin2tap include/bootmenu.b -a 32768 -o mdos3.tap -append
bin2tap include/bootmenu2.b -a 32768 -o mdos3.tap -append
bin2tap include/helpscreen.scr -a 16384 -o mdos3.tap -append
cat zxcdp.tap >> mdos3.tap #ZX CD Player
cat include/monitor.tap >> mdos3.tap #devastace as a monitor and debugger
        # 3. other SYSTEMS for BOOTLOADER
bin2tap include/os/FATware.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/esxide.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/demfir.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sif0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sif2.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sif3.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/TBIOSV14.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sys.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/gasware.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/bsdos0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/bsdos1.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/bsrom0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/bsrom1.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/zx81_128_3.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/zx81_128_0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sifrom0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/sifrom1.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/coloristi0.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/coloristi1.bin -a 8192 -o mdos3.tap -append
bin2tap include/os/azorados.bin -a 8192 -o mdos3.tap -append
        # 4. additional programs only for MDOS3
cat include/add/*.tap >> mdos3.tap
        # 5. other programs from prog folder
cat include/prog/*.tap >> mdos3.tap

 # ************ make images *************************

 tap2d80 -l mdos3.tap bootdisk.d80
 rm mdos3.tap
 cat include/infosecboot.raw > images/bootdisk
 cat bootdisk.d80 >> images/bootdisk ; #rm bootdisk.d80
 rm -f images/my_CF_16M/0bootdisk
 cp images/bootdisk images/my_CF_16M/0bootdisk
 breplace 0x100216 images/bootdisk images/hdf/cf16.hdf
 
fi

